<?php
/*
Plugin Name: Easy Image Slider
Plugin URI: http://angelicanose.weebly.com
Description: The Image Slider plugin displays image slider in your wordpress website.
Version:  1.0
Author: Angelica Defos
License: GPL2 or Later
*/
/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. 

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details. 

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

$thin_Image_Slider_class = new thin_Image_Slider_class();
class thin_Image_Slider_class
{
	function thin_Image_Slider_css()
	{
		$myStyleUrl = WP_PLUGIN_URL . '/image-slider-thinwave/thin_Image_Slider/css/thin_Image_Slider_css.css';
        $myStyleFile = WP_PLUGIN_DIR . '/image-slider-thinwave/thin_Image_Slider/css/thin_Image_Slider_css.css';
        if ( file_exists($myStyleFile) ) 
		{
            wp_register_style('myStyleSheets', $myStyleUrl);
            wp_enqueue_style( 'myStyleSheets');
        }
	}
	
	function thin_Image_Slider_script()
	{
		wp_deregister_script( 'jquery' );
		wp_register_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.6/jquery.min.js');
		wp_enqueue_script( 'jquery' );?>
		<script type="text/javascript">
		var $jquery = jQuery.noConflict(); 
		$jquery(document).ready(function(){
		
	 
	 var slides = $jquery('.thin_slides'); 
	 var numberofSlides = slides.length;
	 var curposition = 0;
	 
	 var slidewidth_extract ='<?php echo get_option('thin_Image_Slider_width');?>';
	 var slidew = parseInt(slidewidth_extract.replace("px",""));
	 var slidewidth = slidew +5;
	 var slidespeed = '<?php echo get_option('thin_sliding_spped');?>';
	 var thin_transition_type = '<?php echo get_option('thin_transition_type');?>';
	 
	 
	 var slideShowInterval;
	 var $k = 1;
	 
	 if(thin_transition_type =='slide')
	 {
		 setImageSliderStyle();
		 slideShowInterval = setInterval(PlayImage,slidespeed);
		 
	 }
	 else
	 {
		 setImageSlideshowStyle();
		 slideShowInterval = setInterval( animatefade, slidespeed );
	 }
	
	 
	function animatefade()
	{
		 var curPic =$jquery('#thin_slideshow div.thin_active');
		 var nexPic = curPic.next();
		 
		 if(nexPic.length==0)
		 {
			 nexPic =$jquery('#thin_slideshow div:first');
		 }
		 
		 curPic.removeClass('thin_active').addClass('prev').fadeOut(1000);
		 nexPic.removeClass('prev').addClass('thin_active').fadeIn(1000);
			 
	}
	 
	 
	 function PlayImage()
	 {	 
		  if( curposition < numberofSlides - 1 && $k==1)
		 {
			 curposition ++;
			  moveSlide();
		 }
		 else
		 {		
			 $k=2;
		 }
		  
		 
		 if( curposition > 0 && $k==2)
		 {
			 curposition--;
			  moveSlide();
		 }
		 else
		 {		
			 $k=1;
		 }
	 }
	
	 function moveSlide()
	 {
		 slides.wrapAll('<div id="slidesHolder"></div>');
	     slides.css({ 'float' : 'left' });  	 
		 $jquery('#slidesHolder').css('width', slidewidth * numberofSlides);
		 $jquery('#slidesHolder').animate({'margin-left':slidewidth*(-curposition)});
		 
	 }
			
				
	});
	
	    function setImageSlideshowStyle()
		{
			var thin_Image_Slider_height ='<?php echo get_option('thin_Image_Slider_height');?>';
	        var thin_Image_Slider_width ='<?php echo get_option('thin_Image_Slider_width');?>';
			var thin_Image_Slider_bg_color ='<?php echo get_option('thin_Image_Slider_bg_color');?>';
			var thin_Image_Slider_border_color ='<?php echo get_option('thin_Image_Slider_border_color');?>';
			var thin_Image_Slider_border_width ='<?php echo get_option('thin_Image_Slider_border_width');?>';
			var thin_Image_Slider_padding ='<?php echo get_option('thin_Image_Slider_padding');?>';
			
			$jquery('#thin_slideshow').css({
           "background-color":thin_Image_Slider_bg_color,
		   "width":thin_Image_Slider_width,
		   "height":thin_Image_Slider_height,
		   "border-width":thin_Image_Slider_border_width,
		   "border-style":"solid",
		   "border-color": thin_Image_Slider_border_color,
		   "padding": thin_Image_Slider_padding});
			
		}
	
		function setImageSliderStyle()
		{
			var thin_Image_Slider_height ='<?php echo get_option('thin_Image_Slider_height');?>';
	        var thin_Image_Slider_width ='<?php echo get_option('thin_Image_Slider_width');?>';
			var thin_Image_Slider_bg_color ='<?php echo get_option('thin_Image_Slider_bg_color');?>';
			var thin_Image_Slider_border_color ='<?php echo get_option('thin_Image_Slider_border_color');?>';
			var thin_Image_Slider_border_width ='<?php echo get_option('thin_Image_Slider_border_width');?>';
			var thin_Image_Slider_padding ='<?php echo get_option('thin_Image_Slider_padding');?>';
			var thin_Slide_Direction ='<?php echo get_option('thin_Slide_Direction');?>';
			
		   $jquery('#thin_Image_Slider').css({
           "background-color":thin_Image_Slider_bg_color,
		   "width":thin_Image_Slider_width,
		   "height":thin_Image_Slider_height,
		   "border-width":thin_Image_Slider_border_width,
		   "border-style":"solid",
		   "border-color": thin_Image_Slider_border_color,
		   "padding": thin_Image_Slider_padding});
		   
		   $jquery('#thin_Image_Slider .thin_slides').css({           
		   "width":thin_Image_Slider_width,
		   "height":thin_Image_Slider_height
		   });
			
		}
	
	 
		</script>
		<?php
		
	}
	
	function thin_Image_Slider_getImage($atts, $content = null)
	{
		$images =& get_children( 'post_type=attachment&post_mime_type=image&post_parent=' . get_the_id() );
		$i=1;
		$charater_length = get_option('thin_Title_Character_Length');
		$thin_caption = get_option('thin_caption');
		$thin_transition_type = get_option('thin_transition_type');;
		
		if($thin_transition_type == 'slide')
		{
			$display_image = '<div id="thin_Image_Slider">';
			foreach( $images as $imageID => $imagePost )
				{   
				if($i==1)
				{
					$i=0;
					$display_image .= '<div class="thin_slides">';
				}
				else
				{
					$display_image .= '<div class="thin_slides">';
				}
					$display_image .= wp_get_attachment_image($imageID, $size, false);	
					$title = get_the_title($imageID);
					$title_length =	strlen(get_the_title($imageID));
					if($thin_caption =='yes')
					{
						$display_image .= '<div class="thin_slidetext">'.substr($title,0,$charater_length);
						if($title_length>$charater_length)
						{
							$display_image .= '. . .';
							
						}
						$display_image .= '</div>';
					}
					$display_image .= '</div>';
					
				}
			$display_image .= '</div>';
		}
		else
		{ // for fade in/out
			
			$display_image = '<div id="thin_slideshow">';
			foreach( $images as $imageID => $imagePost )
				{   
				if($i==1)
				{
					$i=0;
					$display_image .= '<div class="thin_active">';
				}
				else
				{
					$display_image .= '<div>';
				}
					$display_image .= wp_get_attachment_image($imageID, $size, false);
					$title = get_the_title($imageID);
					$title_length =	strlen(get_the_title($imageID));
					if($thin_caption =='yes')
					{		
						$display_image .= '<span>'.substr($title,0,$charater_length);
						if($title_length>$charater_length)
						{
							$display_image .= '. . .';
							
						}
						$display_image .= '</span>';
					}
					$display_image .= '</div>';
					
				} //end foreach
			$display_image .= '</div>';
		} // end else loop
		
		return $display_image;		
	}
	
	function thin_Image_Slider_install()
	{
		add_option('thin_Image_Slider_width','400px','','yes');
		add_option('thin_Image_Slider_height','340px','','yes');
		add_option('thin_Image_Slider_bg_color','#eeeeee','','yes');
		add_option('thin_Image_Slider_border_color','#000000','','yes');
		add_option('thin_Image_Slider_border_width','1px','','yes');
		add_option('thin_Image_Slider_padding','5px','','yes');
		add_option('thin_Title_Character_Length','15','','yes');
		add_option('thin_sliding_spped','2000','','yes');
		add_option('thin_caption','yes','','yes');
		add_option('thin_transition_type','slide','','yes');
		
		
		
	}
	function thin_Image_Slider_uninstall()
	{
		delete_option('thin_Image_Slider_width');
		delete_option('thin_Image_Slider_height');
		delete_option('thin_Image_Slider_bg_color');
		delete_option('thin_Image_Slider_border_color');
		delete_option('thin_Image_Slider_border_width');
		delete_option('thin_Image_Slider_padding');
		delete_option('thin_Title_Character_Length');
		delete_option('thin_sliding_spped');
		delete_option('thin_caption');
		delete_option('thin_transition_type');
	}
	
	function thin_Image_Slider_menu()
	{
		add_options_page('Image Slider','Image Slider','manage_options',__FILE__,array('thin_Image_Slider_class','thin_Image_Slider_menu_page'));  
	}
	function thin_Image_Slider_menu_page()
	{
		?>
        <div class="wrap">
           <h2>Slideshow Settings</h2>
           <?php
		       if($_REQUEST['submit'])
			   {
				   thin_Image_Slider_class::thin_Image_Slider_update_option();
			   }
			       thin_Image_Slider_class::thin_Image_Slider_print_option();
		   ?>
        </div>
        <?php
	}
	
	function thin_Image_Slider_update_option()
	{
		$ok = false;
		
		if($_REQUEST['thin_transition_type'])
		{
			update_option('thin_transition_type',$_REQUEST['thin_transition_type']);
			$ok = true;
			
		}
		if($_REQUEST['thin_caption'])
		{
			update_option('thin_caption',$_REQUEST['thin_caption']);
			$ok = true;
			
		}
		if($_REQUEST['thin_sliding_spped'])
		{
			update_option('thin_sliding_spped',$_REQUEST['thin_sliding_spped']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Title_Character_Length'])
		{
			update_option('thin_Title_Character_Length',$_REQUEST['thin_Title_Character_Length']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Image_Slider_height'])
		{
			update_option('thin_Image_Slider_height',$_REQUEST['thin_Image_Slider_height']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Image_Slider_width'])
		{
			update_option('thin_Image_Slider_width',$_REQUEST['thin_Image_Slider_width']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Image_Slider_border_color'])
		{
			update_option('thin_Image_Slider_border_color',$_REQUEST['thin_Image_Slider_border_color']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Image_Slider_border_width'])
		{
			update_option('thin_Image_Slider_border_width',$_REQUEST['thin_Image_Slider_border_width']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Image_Slider_bg_color'])
		{
			update_option('thin_Image_Slider_bg_color',$_REQUEST['thin_Image_Slider_bg_color']);
			$ok = true;
			
		}
		if($_REQUEST['thin_Image_Slider_padding'])
		{
			update_option('thin_Image_Slider_padding',$_REQUEST['thin_Image_Slider_padding']);
			$ok = true;
			
		}
		
		
		if($ok)
		{?>
           <div id="message" class="updated fade">
           <p>Options Saved</p>
           </div>
        <?php
		}
		else
		{
			?>
           <div id="message" class="error fade">
           <p>Failed to save options</p>
           </div>
        <?php
		}
	}
	
	function thin_Image_Slider_print_option()
	{
		include 'thin_Image_Slider_admin.php';
	}
	
}
add_action('admin_menu',array($thin_Image_Slider_class,'thin_Image_Slider_menu'));
add_action('wp_print_styles', array($thin_Image_Slider_class,'thin_Image_Slider_css'));
add_action('wp_head', array($thin_Image_Slider_class,'thin_Image_Slider_script'));
add_shortcode('thin_Image_Slider_display', array($thin_Image_Slider_class,'thin_Image_Slider_getImage'));
register_activation_hook(__FILE__,array($thin_Image_Slider_class,'thin_Image_Slider_install'));
register_deactivation_hook(__FILE__,array($thin_Image_Slider_class,'thin_Image_Slider_uninstall'));
?>